package com.casic.dcms.fragment.handle;

import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.text.TextUtils;
import android.view.View;

import androidx.annotation.NonNull;
import androidx.lifecycle.Observer;
import androidx.lifecycle.ViewModelProvider;

import com.casic.dcms.R;
import com.casic.dcms.databinding.FragmentHandleCaseBinding;
import com.casic.dcms.model.CaseHandleBean;
import com.casic.dcms.utils.StringHelper;
import com.casic.dcms.view.handle.CaseHandleDetailActivity;
import com.casic.dcms.vm.CaseViewModel;
import com.pengxh.androidx.lite.adapter.NormalRecyclerAdapter;
import com.pengxh.androidx.lite.adapter.ViewHolder;
import com.pengxh.androidx.lite.base.AndroidxBaseFragment;
import com.pengxh.androidx.lite.hub.StringHub;
import com.pengxh.androidx.lite.utils.WeakReferenceHandler;
import com.scwang.smartrefresh.layout.api.RefreshLayout;
import com.scwang.smartrefresh.layout.listener.OnLoadMoreListener;
import com.scwang.smartrefresh.layout.listener.OnRefreshListener;

import java.util.ArrayList;
import java.util.List;

public class CaseOverTimeFragment extends AndroidxBaseFragment<FragmentHandleCaseBinding> {

    private static final String TAG = "OvertimeCaseFragment";
    private WeakReferenceHandler weakReferenceHandler;
    private CaseViewModel caseViewModel;
    private NormalRecyclerAdapter<CaseHandleBean.DataModel.RowsModel> adapter;
    private List<CaseHandleBean.DataModel.RowsModel> dataBeans = new ArrayList<>();
    private int pageIndex = 1;
    private boolean isRefresh, isLoadMore = false;

    @Override
    protected void setupTopBarLayout() {

    }

    @Override
    protected void observeRequestState() {

    }

    @Override
    protected void initData() {
        weakReferenceHandler = new WeakReferenceHandler(callback);
        caseViewModel = new ViewModelProvider(this).get(CaseViewModel.class);
        caseViewModel.caseHandleModel.observe(this, new Observer<CaseHandleBean>() {
            @Override
            public void onChanged(CaseHandleBean resultBean) {
                if (resultBean.getCode() == 200) {
                    List<CaseHandleBean.DataModel.RowsModel> dataRows = resultBean.getData().getRows();
                    if (isRefresh) {
                        adapter.setRefreshData(dataRows);
                        viewBinding.refreshLayout.finishRefresh();
                        isRefresh = false;
                    } else if (isLoadMore) {
                        if (dataRows.size() == 0) {
                            StringHub.show(requireContext(), "到底了，别拉了");
                        }
                        adapter.setLoadMoreData(dataRows);
                        viewBinding.refreshLayout.finishLoadMore();
                        isLoadMore = false;
                    } else {
                        dataBeans = dataRows;
                        weakReferenceHandler.sendEmptyMessage(202104285);
                    }
                }
            }
        });
    }

    @Override
    public void onResume() {
        super.onResume();
        pageIndex = 1;
        obtainHandleCaseList();
    }

    private void obtainHandleCaseList() {
        /**
         * isOvertime	否	String	是否超时,null-所有案卷,1-超时案卷
         * isEmergent	否	String	是否紧急,null-所有案卷,1-紧急案卷
         */
        caseViewModel.obtainHandleCaseList("1", null, pageIndex, false);
    }

    @Override
    protected void initEvent() {
        viewBinding.refreshLayout.setOnRefreshListener(new OnRefreshListener() {
            @Override
            public void onRefresh(@NonNull final RefreshLayout refreshLayout) {
                isRefresh = true;
                pageIndex = 1;
                obtainHandleCaseList();
            }
        });
        viewBinding.refreshLayout.setOnLoadMoreListener(new OnLoadMoreListener() {
            @Override
            public void onLoadMore(@NonNull final RefreshLayout refreshLayout) {
                isLoadMore = true;
                pageIndex++;
                obtainHandleCaseList();
            }
        });
    }

    private final Handler.Callback callback = new Handler.Callback() {
        @Override
        public boolean handleMessage(@NonNull Message msg) {
            if (msg.what == 202104285) {
                if (dataBeans.size() == 0) {
                    viewBinding.emptyView.show(false, "没有案卷需要处理", null, "刷新", new View.OnClickListener() {
                        @Override
                        public void onClick(View v) {
                            pageIndex = 1;
                            obtainHandleCaseList();
                        }
                    });
                } else {
                    viewBinding.emptyView.hide();
                    adapter = new NormalRecyclerAdapter<CaseHandleBean.DataModel.RowsModel>(R.layout.item_case_rv_l, dataBeans) {
                        @Override
                        public void convertView(ViewHolder viewHolder, int position, CaseHandleBean.DataModel.RowsModel item) {
                            String fileIdVerify = item.getFileIdVerify();
                            if (!TextUtils.isEmpty(fileIdVerify)) {
                                String[] split = fileIdVerify.split(",");
                                String firstImage = split[0];
                                if (firstImage.endsWith(".jpg") || firstImage.contains(".jpeg") || firstImage.contains(".png")) {
                                    viewHolder.setImageResource(R.id.caseImageView, StringHelper.appendCompleteURL(firstImage));
                                }
                            }
                            viewHolder.setText(R.id.caseTitleView, StringHub.filterSpaceOrEnter(item.getDescription()))
                                    .setText(R.id.casePlaceView, "发生地点：" + StringHub.filterSpaceOrEnter(item.getFieldintro()))
                                    .setText(R.id.caseTimeView, "上报时间：" + item.getReportTime());
                        }
                    };
                    viewBinding.caseRecyclerView.setAdapter(adapter);
                    adapter.setOnItemClickedListener(new NormalRecyclerAdapter.OnItemClickedListener<CaseHandleBean.DataModel.RowsModel>() {
                        @Override
                        public void onItemClicked(int position, CaseHandleBean.DataModel.RowsModel rowsModel) {
                            Intent intent = new Intent(requireContext(), CaseHandleDetailActivity.class);
                            intent.putExtra("title", "超时案卷");
                            intent.putExtra("id", rowsModel.getId());
                            startActivity(intent);
                        }
                    });
                }
            }
            return true;
        }
    };
}
